# coding: utf-8


"""
IGNORE:
    Nutanix Iam Versioned APIs

    Manage Identity and Access Management of Nutanix clusters.  # noqa: E501

    OpenAPI spec version: 4.0.1-beta-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_iam_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_iam_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501
from ntnx_iam_py_client.models.iam.v4.authn.ApiKeyCustomOptions import ApiKeyCustomOptions  # noqa: F401,E501
from ntnx_iam_py_client.models.iam.v4.authn.ApiKeyStatusType import ApiKeyStatusType  # noqa: F401,E501

class ApiKey(ExternalizableAbstractModel):

    """Credentials in the form of a unique random key for the service account

    :param name: (:attr:`name`) Identifier for the API key in the form of a name
    :type name: 
    :param description: (:attr:`description`) Brief description of the API key
    :type description: 
    :param scope: (:attr:`scope`) An optional set of audiences for the API key, meant to restrict its access to APIs
    :type scope: 
    :param custom_options: (:attr:`custom_options`) 
    :type custom_options: 
    :param api_key: (:attr:`api_key`) The actual API key value, returned only during creation
    :type api_key: 
    :param status: (:attr:`status`) 
    :type status: 
    :param created_time: (:attr:`created_time`) The creation time of the API key
    :type created_time: 
    :param created_by: (:attr:`created_by`) User or service who created the API key
    :type created_by: 
    :param last_used_time: (:attr:`last_used_time`) The time when the API key was last used
    :type last_used_time: 
    :param expiry_time: (:attr:`expiry_time`) The expiry time of the API key
    :type expiry_time: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'scope': 'list[str]',
        'custom_options': 'iam.v4.authn.ApiKeyCustomOptions',
        'api_key': 'str',
        'status': 'iam.v4.authn.ApiKeyStatusType',
        'created_time': 'datetime',
        'created_by': 'str',
        'last_used_time': 'datetime',
        'expiry_time': 'datetime',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'scope': 'scope',
        'custom_options': 'customOptions',
        'api_key': 'apiKey',
        'status': 'status',
        'created_time': 'createdTime',
        'created_by': 'createdBy',
        'last_used_time': 'lastUsedTime',
        'expiry_time': 'expiryTime',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, name=None, description=None, scope=None, custom_options=None, api_key=None, status=None, created_time=None, created_by=None, last_used_time=None, expiry_time=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__name = None
        self.__description = None
        self.__scope = None
        self.__custom_options = None
        self.__api_key = None
        self.__status = None
        self.__created_time = None
        self.__created_by = None
        self.__last_used_time = None
        self.__expiry_time = None
        self.discriminator = None
        if name is not None:
            self.__name = name
        if description is not None:
            self.__description = description
        if scope is not None:
            self.__scope = scope
        if custom_options is not None:
            self.__custom_options = custom_options
        if api_key is not None:
            self.__api_key = api_key
        if status is not None:
            self.__status = status
        if created_time is not None:
            self.__created_time = created_time
        if created_by is not None:
            self.__created_by = created_by
        if last_used_time is not None:
            self.__last_used_time = last_used_time
        if expiry_time is not None:
            self.__expiry_time = expiry_time

    def _initialize_object_type(self):
        return 'iam.v4.authn.ApiKey'

    def _initialize_fq_object_type(self):
        return 'iam.v4.r0.b1.authn.ApiKey'


    @property
    def name(self):
        """
        Identifier for the API key in the form of a name

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__name

    @name.setter
    def name(self, name):
        if name is not None and len(name) > 255:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `255`")  # noqa: E501
        if name is not None and len(name) < 1:
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501
        if name is not None and not re.search('^[^<>;\'()&+%\/\\\\\"`]*$', name):  # noqa: E501
            raise ValueError(r"Invalid value for `name`, must be a follow pattern or equal to `/^[^<>;'()&+%\/\\\\\"`]*$/`")  # noqa: E501

        self.__name = name

    @property
    def description(self):
        """
        Brief description of the API key

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__description

    @description.setter
    def description(self, description):
        if description is not None and len(description) > 1000:
            raise ValueError("Invalid value for `description`, length must be less than or equal to `1000`")  # noqa: E501
        if description is not None and not re.search('^[^<>;()&+%\/\\\\\"`]*$', description):  # noqa: E501
            raise ValueError(r"Invalid value for `description`, must be a follow pattern or equal to `/^[^<>;()&+%\/\\\\\"`]*$/`")  # noqa: E501

        self.__description = description

    @property
    def scope(self):
        """
        An optional set of audiences for the API key, meant to restrict its access to APIs

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__scope

    @scope.setter
    def scope(self, scope):

        self.__scope = scope

    @property
    def custom_options(self):
        """
        

        :type:
            :class:`~ntnx_iam_py_client.models.iam.v4.authn.ApiKeyCustomOptions`
        """  # noqa: E501
        return self.__custom_options

    @custom_options.setter
    def custom_options(self, custom_options):

        self.__custom_options = custom_options

    @property
    def api_key(self):
        """
        The actual API key value, returned only during creation

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__api_key

    @api_key.setter
    def api_key(self, api_key):

        self.__api_key = api_key

    @property
    def status(self):
        """
        

        :type:
            :class:`~ntnx_iam_py_client.models.iam.v4.authn.ApiKeyStatusType`
        """  # noqa: E501
        return self.__status

    @status.setter
    def status(self, status):

        self.__status = status

    @property
    def created_time(self):
        """
        The creation time of the API key

        :type:

                :class:`~datetime`
        """  # noqa: E501
        return self.__created_time

    @created_time.setter
    def created_time(self, created_time):

        self.__created_time = created_time

    @property
    def created_by(self):
        """
        User or service who created the API key

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__created_by

    @created_by.setter
    def created_by(self, created_by):

        self.__created_by = created_by

    @property
    def last_used_time(self):
        """
        The time when the API key was last used

        :type:

                :class:`~datetime`
        """  # noqa: E501
        return self.__last_used_time

    @last_used_time.setter
    def last_used_time(self, last_used_time):

        self.__last_used_time = last_used_time

    @property
    def expiry_time(self):
        """
        The expiry time of the API key

        :type:

                :class:`~datetime`
        """  # noqa: E501
        return self.__expiry_time

    @expiry_time.setter
    def expiry_time(self, expiry_time):

        self.__expiry_time = expiry_time

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(ApiKey, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApiKey):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

