# coding: utf-8


"""
IGNORE:
    Nutanix Iam Versioned APIs

    Manage Identity and Access Management of Nutanix clusters.  # noqa: E501

    OpenAPI spec version: 4.0.1-beta-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_iam_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_iam_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501

class BucketsAccessKey(ExternalizableAbstractModel):

    """Information of Bucket access key

    :param access_key_name: (:attr:`access_key_name`) Name of the bucket access key
    :type access_key_name: required
    :param secret_access_key: (:attr:`secret_access_key`) Secret access key, it will be returned only during bucket access key creation
    :type secret_access_key: 
    :param user_id: (:attr:`user_id`) User Identifier who owns the bucket access key
    :type user_id: required
    :param created_time: (:attr:`created_time`) Creation time for the bucket access key
    :type created_time: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'access_key_name': 'str',
        'secret_access_key': 'str',
        'user_id': 'str',
        'created_time': 'datetime',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'access_key_name': 'accessKeyName',
        'secret_access_key': 'secretAccessKey',
        'user_id': 'userId',
        'created_time': 'createdTime',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, access_key_name=None, secret_access_key=None, user_id=None, created_time=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__access_key_name = None
        self.__secret_access_key = None
        self.__user_id = None
        self.__created_time = None
        self.discriminator = None
        self.__access_key_name = access_key_name
        if secret_access_key is not None:
            self.__secret_access_key = secret_access_key
        self.__user_id = user_id
        if created_time is not None:
            self.__created_time = created_time

    def _initialize_object_type(self):
        return 'iam.v4.authn.BucketsAccessKey'

    def _initialize_fq_object_type(self):
        return 'iam.v4.r0.b1.authn.BucketsAccessKey'


    @property
    def access_key_name(self):
        """
        Name of the bucket access key

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__access_key_name

    @access_key_name.setter
    def access_key_name(self, access_key_name):
        if access_key_name is None:
            raise ValueError("Invalid value for `access_key_name`, must not be `None`")  # noqa: E501
        if access_key_name is not None and len(access_key_name) > 255:
            raise ValueError("Invalid value for `access_key_name`, length must be less than or equal to `255`")  # noqa: E501
        if access_key_name is not None and len(access_key_name) < 1:
            raise ValueError("Invalid value for `access_key_name`, length must be greater than or equal to `1`")  # noqa: E501
        if access_key_name is not None and not re.search('^[^<>;\'()&+%\/\\\\\"`]*$', access_key_name):  # noqa: E501
            raise ValueError(r"Invalid value for `access_key_name`, must be a follow pattern or equal to `/^[^<>;'()&+%\/\\\\\"`]*$/`")  # noqa: E501

        self.__access_key_name = access_key_name

    @property
    def secret_access_key(self):
        """
        Secret access key, it will be returned only during bucket access key creation

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__secret_access_key

    @secret_access_key.setter
    def secret_access_key(self, secret_access_key):

        self.__secret_access_key = secret_access_key

    @property
    def user_id(self):
        """
        User Identifier who owns the bucket access key

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__user_id

    @user_id.setter
    def user_id(self, user_id):
        if user_id is None:
            raise ValueError("Invalid value for `user_id`, must not be `None`")  # noqa: E501
        if user_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', user_id):  # noqa: E501
            raise ValueError(r"Invalid value for `user_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__user_id = user_id

    @property
    def created_time(self):
        """
        Creation time for the bucket access key

        :type:

                :class:`~datetime`
        """  # noqa: E501
        return self.__created_time

    @created_time.setter
    def created_time(self, created_time):

        self.__created_time = created_time

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(BucketsAccessKey, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BucketsAccessKey):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

