# coding: utf-8


"""
IGNORE:
    Nutanix Iam Versioned APIs

    Manage Identity and Access Management of Nutanix clusters.  # noqa: E501

    OpenAPI spec version: 4.0.1-beta-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_iam_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_iam_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501

class ServiceAccountKey(ExternalizableAbstractModel):

    """Credentials in the form of a private key and certificate for the service account, for authentication over mTLS

    :param name: (:attr:`name`) Identifier of the service account key in the form of a name
    :type name: 
    :param description: (:attr:`description`) Brief description of the service account key
    :type description: 
    :param serial_number: (:attr:`serial_number`) Serial number of the certificate
    :type serial_number: 
    :param certificate: (:attr:`certificate`) X509 certificate signed by IAM in PEM format (includes leaf as well as ICAs), returned only during creation
    :type certificate: 
    :param private_key: (:attr:`private_key`) RSA private key encoded in PEM format, returned only during creation
    :type private_key: 
    :param created_time: (:attr:`created_time`) User or service who created the nutanix access key
    :type created_time: 
    :param created_by: (:attr:`created_by`) Creation time for the nutanix access key
    :type created_by: 
    :param expiry_time: (:attr:`expiry_time`) Expiry time of the certificate
    :type expiry_time: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'serial_number': 'str',
        'certificate': 'str',
        'private_key': 'str',
        'created_time': 'datetime',
        'created_by': 'str',
        'expiry_time': 'datetime',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'serial_number': 'serialNumber',
        'certificate': 'certificate',
        'private_key': 'privateKey',
        'created_time': 'createdTime',
        'created_by': 'createdBy',
        'expiry_time': 'expiryTime',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, name=None, description=None, serial_number=None, certificate=None, private_key=None, created_time=None, created_by=None, expiry_time=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__name = None
        self.__description = None
        self.__serial_number = None
        self.__certificate = None
        self.__private_key = None
        self.__created_time = None
        self.__created_by = None
        self.__expiry_time = None
        self.discriminator = None
        if name is not None:
            self.__name = name
        if description is not None:
            self.__description = description
        if serial_number is not None:
            self.__serial_number = serial_number
        if certificate is not None:
            self.__certificate = certificate
        if private_key is not None:
            self.__private_key = private_key
        if created_time is not None:
            self.__created_time = created_time
        if created_by is not None:
            self.__created_by = created_by
        if expiry_time is not None:
            self.__expiry_time = expiry_time

    def _initialize_object_type(self):
        return 'iam.v4.authn.ServiceAccountKey'

    def _initialize_fq_object_type(self):
        return 'iam.v4.r0.b1.authn.ServiceAccountKey'


    @property
    def name(self):
        """
        Identifier of the service account key in the form of a name

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__name

    @name.setter
    def name(self, name):
        if name is not None and len(name) > 255:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `255`")  # noqa: E501
        if name is not None and len(name) < 1:
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501
        if name is not None and not re.search('^[^<>;\'()&+%\/\\\\\"`]*$', name):  # noqa: E501
            raise ValueError(r"Invalid value for `name`, must be a follow pattern or equal to `/^[^<>;'()&+%\/\\\\\"`]*$/`")  # noqa: E501

        self.__name = name

    @property
    def description(self):
        """
        Brief description of the service account key

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__description

    @description.setter
    def description(self, description):
        if description is not None and len(description) > 1000:
            raise ValueError("Invalid value for `description`, length must be less than or equal to `1000`")  # noqa: E501
        if description is not None and not re.search('^[^<>;()&+%\/\\\\\"`]*$', description):  # noqa: E501
            raise ValueError(r"Invalid value for `description`, must be a follow pattern or equal to `/^[^<>;()&+%\/\\\\\"`]*$/`")  # noqa: E501

        self.__description = description

    @property
    def serial_number(self):
        """
        Serial number of the certificate

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__serial_number

    @serial_number.setter
    def serial_number(self, serial_number):

        self.__serial_number = serial_number

    @property
    def certificate(self):
        """
        X509 certificate signed by IAM in PEM format (includes leaf as well as ICAs), returned only during creation

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__certificate

    @certificate.setter
    def certificate(self, certificate):

        self.__certificate = certificate

    @property
    def private_key(self):
        """
        RSA private key encoded in PEM format, returned only during creation

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__private_key

    @private_key.setter
    def private_key(self, private_key):

        self.__private_key = private_key

    @property
    def created_time(self):
        """
        User or service who created the nutanix access key

        :type:

                :class:`~datetime`
        """  # noqa: E501
        return self.__created_time

    @created_time.setter
    def created_time(self, created_time):

        self.__created_time = created_time

    @property
    def created_by(self):
        """
        Creation time for the nutanix access key

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__created_by

    @created_by.setter
    def created_by(self, created_by):

        self.__created_by = created_by

    @property
    def expiry_time(self):
        """
        Expiry time of the certificate

        :type:

                :class:`~datetime`
        """  # noqa: E501
        return self.__expiry_time

    @expiry_time.setter
    def expiry_time(self, expiry_time):

        self.__expiry_time = expiry_time

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(ServiceAccountKey, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ServiceAccountKey):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

